# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictInt, StrictStr
from typing import Optional
from typing_extensions import Annotated
from slack_ti.models.default_success_template import DefaultSuccessTemplate

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class AdminInviteRequestsApprovedApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def admin_invite_requests_approved_list(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.invites:read`")],
        team_id: Annotated[Optional[StrictStr], Field(description="ID for the workspace where the invite requests were made.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Value of the `next_cursor` field sent as part of the previous API response")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DefaultSuccessTemplate:
        """admin_invite_requests_approved_list

        List all approved workspace invite requests.

        :param token: Authentication token. Requires scope: `admin.invites:read` (required)
        :type token: str
        :param team_id: ID for the workspace where the invite requests were made.
        :type team_id: str
        :param cursor: Value of the `next_cursor` field sent as part of the previous API response
        :type cursor: str
        :param limit: The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive
        :type limit: int
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_invite_requests_approved_list_serialize(
            token=token,
            team_id=team_id,
            cursor=cursor,
            limit=limit,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def admin_invite_requests_approved_list_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.invites:read`")],
        team_id: Annotated[Optional[StrictStr], Field(description="ID for the workspace where the invite requests were made.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Value of the `next_cursor` field sent as part of the previous API response")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DefaultSuccessTemplate]:
        """admin_invite_requests_approved_list

        List all approved workspace invite requests.

        :param token: Authentication token. Requires scope: `admin.invites:read` (required)
        :type token: str
        :param team_id: ID for the workspace where the invite requests were made.
        :type team_id: str
        :param cursor: Value of the `next_cursor` field sent as part of the previous API response
        :type cursor: str
        :param limit: The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive
        :type limit: int
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_invite_requests_approved_list_serialize(
            token=token,
            team_id=team_id,
            cursor=cursor,
            limit=limit,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def admin_invite_requests_approved_list_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.invites:read`")],
        team_id: Annotated[Optional[StrictStr], Field(description="ID for the workspace where the invite requests were made.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Value of the `next_cursor` field sent as part of the previous API response")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """admin_invite_requests_approved_list

        List all approved workspace invite requests.

        :param token: Authentication token. Requires scope: `admin.invites:read` (required)
        :type token: str
        :param team_id: ID for the workspace where the invite requests were made.
        :type team_id: str
        :param cursor: Value of the `next_cursor` field sent as part of the previous API response
        :type cursor: str
        :param limit: The number of results that will be returned by the API on each invocation. Must be between 1 - 1000, both inclusive
        :type limit: int
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_invite_requests_approved_list_serialize(
            token=token,
            team_id=team_id,
            cursor=cursor,
            limit=limit,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _admin_invite_requests_approved_list_serialize(
        self,
        token,
        team_id,
        cursor,
        limit,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if team_id is not None:
            
            _query_params.append(('team_id', team_id))
            
        if cursor is not None:
            
            _query_params.append(('cursor', cursor))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/admin.inviteRequests.approved.list',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


