# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictInt, StrictStr
from typing import Optional
from typing_extensions import Annotated
from slack_ti.models.default_success_template import DefaultSuccessTemplate

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class AdminTeamsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def admin_teams_create(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:write`")],
        team_domain: Annotated[StrictStr, Field(description="Team domain (for example, slacksoftballteam).")],
        team_name: Annotated[StrictStr, Field(description="Team name (for example, Slack Softball Team).")],
        team_description: Annotated[Optional[StrictStr], Field(description="Description for the team.")] = None,
        team_discoverability: Annotated[Optional[StrictStr], Field(description="Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DefaultSuccessTemplate:
        """admin_teams_create

        Create an Enterprise team.

        :param token: Authentication token. Requires scope: `admin.teams:write` (required)
        :type token: str
        :param team_domain: Team domain (for example, slacksoftballteam). (required)
        :type team_domain: str
        :param team_name: Team name (for example, Slack Softball Team). (required)
        :type team_name: str
        :param team_description: Description for the team.
        :type team_description: str
        :param team_discoverability: Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.
        :type team_discoverability: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_create_serialize(
            token=token,
            team_domain=team_domain,
            team_name=team_name,
            team_description=team_description,
            team_discoverability=team_discoverability,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def admin_teams_create_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:write`")],
        team_domain: Annotated[StrictStr, Field(description="Team domain (for example, slacksoftballteam).")],
        team_name: Annotated[StrictStr, Field(description="Team name (for example, Slack Softball Team).")],
        team_description: Annotated[Optional[StrictStr], Field(description="Description for the team.")] = None,
        team_discoverability: Annotated[Optional[StrictStr], Field(description="Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DefaultSuccessTemplate]:
        """admin_teams_create

        Create an Enterprise team.

        :param token: Authentication token. Requires scope: `admin.teams:write` (required)
        :type token: str
        :param team_domain: Team domain (for example, slacksoftballteam). (required)
        :type team_domain: str
        :param team_name: Team name (for example, Slack Softball Team). (required)
        :type team_name: str
        :param team_description: Description for the team.
        :type team_description: str
        :param team_discoverability: Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.
        :type team_discoverability: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_create_serialize(
            token=token,
            team_domain=team_domain,
            team_name=team_name,
            team_description=team_description,
            team_discoverability=team_discoverability,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def admin_teams_create_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:write`")],
        team_domain: Annotated[StrictStr, Field(description="Team domain (for example, slacksoftballteam).")],
        team_name: Annotated[StrictStr, Field(description="Team name (for example, Slack Softball Team).")],
        team_description: Annotated[Optional[StrictStr], Field(description="Description for the team.")] = None,
        team_discoverability: Annotated[Optional[StrictStr], Field(description="Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """admin_teams_create

        Create an Enterprise team.

        :param token: Authentication token. Requires scope: `admin.teams:write` (required)
        :type token: str
        :param team_domain: Team domain (for example, slacksoftballteam). (required)
        :type team_domain: str
        :param team_name: Team name (for example, Slack Softball Team). (required)
        :type team_name: str
        :param team_description: Description for the team.
        :type team_description: str
        :param team_discoverability: Who can join the team. A team's discoverability can be `open`, `closed`, `invite_only`, or `unlisted`.
        :type team_discoverability: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_create_serialize(
            token=token,
            team_domain=team_domain,
            team_name=team_name,
            team_description=team_description,
            team_discoverability=team_discoverability,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _admin_teams_create_serialize(
        self,
        token,
        team_domain,
        team_name,
        team_description,
        team_discoverability,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        if team_domain is not None:
            _form_params.append(('team_domain', team_domain))
        if team_name is not None:
            _form_params.append(('team_name', team_name))
        if team_description is not None:
            _form_params.append(('team_description', team_description))
        if team_discoverability is not None:
            _form_params.append(('team_discoverability', team_discoverability))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded', 
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/admin.teams.create',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def admin_teams_list(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:read`")],
        limit: Annotated[Optional[StrictInt], Field(description="The maximum number of items to return. Must be between 1 - 100 both inclusive.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DefaultSuccessTemplate:
        """admin_teams_list

        List all teams on an Enterprise organization

        :param token: Authentication token. Requires scope: `admin.teams:read` (required)
        :type token: str
        :param limit: The maximum number of items to return. Must be between 1 - 100 both inclusive.
        :type limit: int
        :param cursor: Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.
        :type cursor: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_list_serialize(
            token=token,
            limit=limit,
            cursor=cursor,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def admin_teams_list_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:read`")],
        limit: Annotated[Optional[StrictInt], Field(description="The maximum number of items to return. Must be between 1 - 100 both inclusive.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DefaultSuccessTemplate]:
        """admin_teams_list

        List all teams on an Enterprise organization

        :param token: Authentication token. Requires scope: `admin.teams:read` (required)
        :type token: str
        :param limit: The maximum number of items to return. Must be between 1 - 100 both inclusive.
        :type limit: int
        :param cursor: Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.
        :type cursor: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_list_serialize(
            token=token,
            limit=limit,
            cursor=cursor,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def admin_teams_list_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `admin.teams:read`")],
        limit: Annotated[Optional[StrictInt], Field(description="The maximum number of items to return. Must be between 1 - 100 both inclusive.")] = None,
        cursor: Annotated[Optional[StrictStr], Field(description="Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """admin_teams_list

        List all teams on an Enterprise organization

        :param token: Authentication token. Requires scope: `admin.teams:read` (required)
        :type token: str
        :param limit: The maximum number of items to return. Must be between 1 - 100 both inclusive.
        :type limit: int
        :param cursor: Set `cursor` to `next_cursor` returned by the previous call to list items in the next page.
        :type cursor: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._admin_teams_list_serialize(
            token=token,
            limit=limit,
            cursor=cursor,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _admin_teams_list_serialize(
        self,
        token,
        limit,
        cursor,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if cursor is not None:
            
            _query_params.append(('cursor', cursor))
            
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/admin.teams.list',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


