# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing_extensions import Annotated
from slack_ti.models.default_success_template import DefaultSuccessTemplate

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class CallsParticipantsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def calls_participants_add(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DefaultSuccessTemplate:
        """calls_participants_add

        Registers new participants added to a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_add_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def calls_participants_add_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DefaultSuccessTemplate]:
        """calls_participants_add

        Registers new participants added to a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_add_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def calls_participants_add_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """calls_participants_add

        Registers new participants added to a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to add as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_add_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _calls_participants_add_serialize(
        self,
        token,
        id,
        users,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        if id is not None:
            _form_params.append(('id', id))
        if users is not None:
            _form_params.append(('users', users))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded', 
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/calls.participants.add',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def calls_participants_remove(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DefaultSuccessTemplate:
        """calls_participants_remove

        Registers participants removed from a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_remove_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def calls_participants_remove_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DefaultSuccessTemplate]:
        """calls_participants_remove

        Registers participants removed from a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_remove_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def calls_participants_remove_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `calls:write`")],
        id: Annotated[StrictStr, Field(description="`id` returned by the [`calls.add`](/methods/calls.add) method.")],
        users: Annotated[StrictStr, Field(description="The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users).")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """calls_participants_remove

        Registers participants removed from a Call.

        :param token: Authentication token. Requires scope: `calls:write` (required)
        :type token: str
        :param id: `id` returned by the [`calls.add`](/methods/calls.add) method. (required)
        :type id: str
        :param users: The list of users to remove as participants in the Call. [Read more on how to specify users here](/apis/calls#users). (required)
        :type users: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._calls_participants_remove_serialize(
            token=token,
            id=id,
            users=users,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DefaultSuccessTemplate",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _calls_participants_remove_serialize(
        self,
        token,
        id,
        users,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        if id is not None:
            _form_params.append(('id', id))
        if users is not None:
            _form_params.append(('users', users))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded', 
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/calls.participants.remove',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


