# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr
from typing_extensions import Annotated
from slack_ti.models.dialog_open_schema import DialogOpenSchema

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class DialogApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def dialog_open(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `none`")],
        dialog: Annotated[StrictStr, Field(description="The dialog definition. This must be a JSON-encoded string.")],
        trigger_id: Annotated[StrictStr, Field(description="Exchange a trigger to post to the user.")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> DialogOpenSchema:
        """dialog_open

        Open a dialog with a user

        :param token: Authentication token. Requires scope: `none` (required)
        :type token: str
        :param dialog: The dialog definition. This must be a JSON-encoded string. (required)
        :type dialog: str
        :param trigger_id: Exchange a trigger to post to the user. (required)
        :type trigger_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._dialog_open_serialize(
            token=token,
            dialog=dialog,
            trigger_id=trigger_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DialogOpenSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def dialog_open_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `none`")],
        dialog: Annotated[StrictStr, Field(description="The dialog definition. This must be a JSON-encoded string.")],
        trigger_id: Annotated[StrictStr, Field(description="Exchange a trigger to post to the user.")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[DialogOpenSchema]:
        """dialog_open

        Open a dialog with a user

        :param token: Authentication token. Requires scope: `none` (required)
        :type token: str
        :param dialog: The dialog definition. This must be a JSON-encoded string. (required)
        :type dialog: str
        :param trigger_id: Exchange a trigger to post to the user. (required)
        :type trigger_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._dialog_open_serialize(
            token=token,
            dialog=dialog,
            trigger_id=trigger_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DialogOpenSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def dialog_open_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `none`")],
        dialog: Annotated[StrictStr, Field(description="The dialog definition. This must be a JSON-encoded string.")],
        trigger_id: Annotated[StrictStr, Field(description="Exchange a trigger to post to the user.")],
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """dialog_open

        Open a dialog with a user

        :param token: Authentication token. Requires scope: `none` (required)
        :type token: str
        :param dialog: The dialog definition. This must be a JSON-encoded string. (required)
        :type dialog: str
        :param trigger_id: Exchange a trigger to post to the user. (required)
        :type trigger_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._dialog_open_serialize(
            token=token,
            dialog=dialog,
            trigger_id=trigger_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DialogOpenSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _dialog_open_serialize(
        self,
        token,
        dialog,
        trigger_id,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if dialog is not None:
            
            _query_params.append(('dialog', dialog))
            
        if trigger_id is not None:
            
            _query_params.append(('trigger_id', trigger_id))
            
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/dialog.open',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


