# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictStr
from typing import Optional
from typing_extensions import Annotated
from slack_ti.models.migration_exchange_success_schema import MigrationExchangeSuccessSchema

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class MigrationApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def migration_exchange(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `tokens.basic`")],
        users: Annotated[StrictStr, Field(description="A comma-separated list of user ids, up to 400 per request")],
        team_id: Annotated[Optional[StrictStr], Field(description="Specify team_id starts with `T` in case of Org Token")] = None,
        to_old: Annotated[Optional[StrictBool], Field(description="Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> MigrationExchangeSuccessSchema:
        """migration_exchange

        For Enterprise Grid workspaces, map local user IDs to global user IDs

        :param token: Authentication token. Requires scope: `tokens.basic` (required)
        :type token: str
        :param users: A comma-separated list of user ids, up to 400 per request (required)
        :type users: str
        :param team_id: Specify team_id starts with `T` in case of Org Token
        :type team_id: str
        :param to_old: Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.
        :type to_old: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._migration_exchange_serialize(
            token=token,
            users=users,
            team_id=team_id,
            to_old=to_old,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MigrationExchangeSuccessSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def migration_exchange_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `tokens.basic`")],
        users: Annotated[StrictStr, Field(description="A comma-separated list of user ids, up to 400 per request")],
        team_id: Annotated[Optional[StrictStr], Field(description="Specify team_id starts with `T` in case of Org Token")] = None,
        to_old: Annotated[Optional[StrictBool], Field(description="Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[MigrationExchangeSuccessSchema]:
        """migration_exchange

        For Enterprise Grid workspaces, map local user IDs to global user IDs

        :param token: Authentication token. Requires scope: `tokens.basic` (required)
        :type token: str
        :param users: A comma-separated list of user ids, up to 400 per request (required)
        :type users: str
        :param team_id: Specify team_id starts with `T` in case of Org Token
        :type team_id: str
        :param to_old: Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.
        :type to_old: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._migration_exchange_serialize(
            token=token,
            users=users,
            team_id=team_id,
            to_old=to_old,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MigrationExchangeSuccessSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def migration_exchange_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `tokens.basic`")],
        users: Annotated[StrictStr, Field(description="A comma-separated list of user ids, up to 400 per request")],
        team_id: Annotated[Optional[StrictStr], Field(description="Specify team_id starts with `T` in case of Org Token")] = None,
        to_old: Annotated[Optional[StrictBool], Field(description="Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """migration_exchange

        For Enterprise Grid workspaces, map local user IDs to global user IDs

        :param token: Authentication token. Requires scope: `tokens.basic` (required)
        :type token: str
        :param users: A comma-separated list of user ids, up to 400 per request (required)
        :type users: str
        :param team_id: Specify team_id starts with `T` in case of Org Token
        :type team_id: str
        :param to_old: Specify `true` to convert `W` global user IDs to workspace-specific `U` IDs. Defaults to `false`.
        :type to_old: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._migration_exchange_serialize(
            token=token,
            users=users,
            team_id=team_id,
            to_old=to_old,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "MigrationExchangeSuccessSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _migration_exchange_serialize(
        self,
        token,
        users,
        team_id,
        to_old,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if token is not None:
            
            _query_params.append(('token', token))
            
        if users is not None:
            
            _query_params.append(('users', users))
            
        if team_id is not None:
            
            _query_params.append(('team_id', team_id))
            
        if to_old is not None:
            
            _query_params.append(('to_old', to_old))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/migration.exchange',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


