# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictStr
from typing import Optional
from typing_extensions import Annotated
from slack_ti.models.usergroups_users_list_schema import UsergroupsUsersListSchema
from slack_ti.models.usergroups_users_update_schema import UsergroupsUsersUpdateSchema

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class UsergroupsUsersApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def usergroups_users_list(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:read`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        include_disabled: Annotated[Optional[StrictBool], Field(description="Allow results that involve disabled User Groups.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> UsergroupsUsersListSchema:
        """usergroups_users_list

        List all users in a User Group

        :param token: Authentication token. Requires scope: `usergroups:read` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param include_disabled: Allow results that involve disabled User Groups.
        :type include_disabled: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_list_serialize(
            token=token,
            usergroup=usergroup,
            include_disabled=include_disabled,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersListSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def usergroups_users_list_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:read`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        include_disabled: Annotated[Optional[StrictBool], Field(description="Allow results that involve disabled User Groups.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[UsergroupsUsersListSchema]:
        """usergroups_users_list

        List all users in a User Group

        :param token: Authentication token. Requires scope: `usergroups:read` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param include_disabled: Allow results that involve disabled User Groups.
        :type include_disabled: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_list_serialize(
            token=token,
            usergroup=usergroup,
            include_disabled=include_disabled,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersListSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def usergroups_users_list_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:read`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        include_disabled: Annotated[Optional[StrictBool], Field(description="Allow results that involve disabled User Groups.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """usergroups_users_list

        List all users in a User Group

        :param token: Authentication token. Requires scope: `usergroups:read` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param include_disabled: Allow results that involve disabled User Groups.
        :type include_disabled: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_list_serialize(
            token=token,
            usergroup=usergroup,
            include_disabled=include_disabled,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersListSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _usergroups_users_list_serialize(
        self,
        token,
        usergroup,
        include_disabled,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if token is not None:
            
            _query_params.append(('token', token))
            
        if include_disabled is not None:
            
            _query_params.append(('include_disabled', include_disabled))
            
        if usergroup is not None:
            
            _query_params.append(('usergroup', usergroup))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/usergroups.users.list',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def usergroups_users_update(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:write`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        users: Annotated[StrictStr, Field(description="A comma separated string of encoded user IDs that represent the entire list of users for the User Group.")],
        include_count: Annotated[Optional[StrictBool], Field(description="Include the number of users in the User Group.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> UsergroupsUsersUpdateSchema:
        """usergroups_users_update

        Update the list of users for a User Group

        :param token: Authentication token. Requires scope: `usergroups:write` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param users: A comma separated string of encoded user IDs that represent the entire list of users for the User Group. (required)
        :type users: str
        :param include_count: Include the number of users in the User Group.
        :type include_count: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_update_serialize(
            token=token,
            usergroup=usergroup,
            users=users,
            include_count=include_count,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersUpdateSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def usergroups_users_update_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:write`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        users: Annotated[StrictStr, Field(description="A comma separated string of encoded user IDs that represent the entire list of users for the User Group.")],
        include_count: Annotated[Optional[StrictBool], Field(description="Include the number of users in the User Group.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[UsergroupsUsersUpdateSchema]:
        """usergroups_users_update

        Update the list of users for a User Group

        :param token: Authentication token. Requires scope: `usergroups:write` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param users: A comma separated string of encoded user IDs that represent the entire list of users for the User Group. (required)
        :type users: str
        :param include_count: Include the number of users in the User Group.
        :type include_count: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_update_serialize(
            token=token,
            usergroup=usergroup,
            users=users,
            include_count=include_count,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersUpdateSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def usergroups_users_update_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `usergroups:write`")],
        usergroup: Annotated[StrictStr, Field(description="The encoded ID of the User Group to update.")],
        users: Annotated[StrictStr, Field(description="A comma separated string of encoded user IDs that represent the entire list of users for the User Group.")],
        include_count: Annotated[Optional[StrictBool], Field(description="Include the number of users in the User Group.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """usergroups_users_update

        Update the list of users for a User Group

        :param token: Authentication token. Requires scope: `usergroups:write` (required)
        :type token: str
        :param usergroup: The encoded ID of the User Group to update. (required)
        :type usergroup: str
        :param users: A comma separated string of encoded user IDs that represent the entire list of users for the User Group. (required)
        :type users: str
        :param include_count: Include the number of users in the User Group.
        :type include_count: bool
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._usergroups_users_update_serialize(
            token=token,
            usergroup=usergroup,
            users=users,
            include_count=include_count,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsergroupsUsersUpdateSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _usergroups_users_update_serialize(
        self,
        token,
        usergroup,
        users,
        include_count,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        if include_count is not None:
            _form_params.append(('include_count', include_count))
        if usergroup is not None:
            _form_params.append(('usergroup', usergroup))
        if users is not None:
            _form_params.append(('users', users))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded', 
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/usergroups.users.update',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


