# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictStr
from typing import Optional
from typing_extensions import Annotated
from slack_ti.models.users_profile_get_schema import UsersProfileGetSchema
from slack_ti.models.users_profile_set_schema import UsersProfileSetSchema

from slack_ti.api_client import ApiClient, RequestSerialized
from slack_ti.api_response import ApiResponse
from slack_ti.rest import RESTResponseType


class UsersProfileApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def users_profile_get(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:read`")],
        include_labels: Annotated[Optional[StrictBool], Field(description="Include labels for each ID in custom profile fields")] = None,
        user: Annotated[Optional[StrictStr], Field(description="User to retrieve profile info for")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> UsersProfileGetSchema:
        """users_profile_get

        Retrieves a user's profile information.

        :param token: Authentication token. Requires scope: `users.profile:read` (required)
        :type token: str
        :param include_labels: Include labels for each ID in custom profile fields
        :type include_labels: bool
        :param user: User to retrieve profile info for
        :type user: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_get_serialize(
            token=token,
            include_labels=include_labels,
            user=user,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileGetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def users_profile_get_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:read`")],
        include_labels: Annotated[Optional[StrictBool], Field(description="Include labels for each ID in custom profile fields")] = None,
        user: Annotated[Optional[StrictStr], Field(description="User to retrieve profile info for")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[UsersProfileGetSchema]:
        """users_profile_get

        Retrieves a user's profile information.

        :param token: Authentication token. Requires scope: `users.profile:read` (required)
        :type token: str
        :param include_labels: Include labels for each ID in custom profile fields
        :type include_labels: bool
        :param user: User to retrieve profile info for
        :type user: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_get_serialize(
            token=token,
            include_labels=include_labels,
            user=user,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileGetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def users_profile_get_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:read`")],
        include_labels: Annotated[Optional[StrictBool], Field(description="Include labels for each ID in custom profile fields")] = None,
        user: Annotated[Optional[StrictStr], Field(description="User to retrieve profile info for")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """users_profile_get

        Retrieves a user's profile information.

        :param token: Authentication token. Requires scope: `users.profile:read` (required)
        :type token: str
        :param include_labels: Include labels for each ID in custom profile fields
        :type include_labels: bool
        :param user: User to retrieve profile info for
        :type user: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_get_serialize(
            token=token,
            include_labels=include_labels,
            user=user,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileGetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _users_profile_get_serialize(
        self,
        token,
        include_labels,
        user,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if token is not None:
            
            _query_params.append(('token', token))
            
        if include_labels is not None:
            
            _query_params.append(('include_labels', include_labels))
            
        if user is not None:
            
            _query_params.append(('user', user))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/users.profile.get',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def users_profile_set(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:write`")],
        name: Annotated[Optional[StrictStr], Field(description="Name of a single key to set. Usable only if `profile` is not passed.")] = None,
        profile: Annotated[Optional[StrictStr], Field(description="Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.")] = None,
        user: Annotated[Optional[StrictStr], Field(description="ID of user to change. This argument may only be specified by team admins on paid teams.")] = None,
        value: Annotated[Optional[StrictStr], Field(description="Value to set a single key to. Usable only if `profile` is not passed.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> UsersProfileSetSchema:
        """users_profile_set

        Set the profile information for a user.

        :param token: Authentication token. Requires scope: `users.profile:write` (required)
        :type token: str
        :param name: Name of a single key to set. Usable only if `profile` is not passed.
        :type name: str
        :param profile: Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.
        :type profile: str
        :param user: ID of user to change. This argument may only be specified by team admins on paid teams.
        :type user: str
        :param value: Value to set a single key to. Usable only if `profile` is not passed.
        :type value: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_set_serialize(
            token=token,
            name=name,
            profile=profile,
            user=user,
            value=value,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileSetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def users_profile_set_with_http_info(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:write`")],
        name: Annotated[Optional[StrictStr], Field(description="Name of a single key to set. Usable only if `profile` is not passed.")] = None,
        profile: Annotated[Optional[StrictStr], Field(description="Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.")] = None,
        user: Annotated[Optional[StrictStr], Field(description="ID of user to change. This argument may only be specified by team admins on paid teams.")] = None,
        value: Annotated[Optional[StrictStr], Field(description="Value to set a single key to. Usable only if `profile` is not passed.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[UsersProfileSetSchema]:
        """users_profile_set

        Set the profile information for a user.

        :param token: Authentication token. Requires scope: `users.profile:write` (required)
        :type token: str
        :param name: Name of a single key to set. Usable only if `profile` is not passed.
        :type name: str
        :param profile: Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.
        :type profile: str
        :param user: ID of user to change. This argument may only be specified by team admins on paid teams.
        :type user: str
        :param value: Value to set a single key to. Usable only if `profile` is not passed.
        :type value: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_set_serialize(
            token=token,
            name=name,
            profile=profile,
            user=user,
            value=value,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileSetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def users_profile_set_without_preload_content(
        self,
        token: Annotated[StrictStr, Field(description="Authentication token. Requires scope: `users.profile:write`")],
        name: Annotated[Optional[StrictStr], Field(description="Name of a single key to set. Usable only if `profile` is not passed.")] = None,
        profile: Annotated[Optional[StrictStr], Field(description="Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.")] = None,
        user: Annotated[Optional[StrictStr], Field(description="ID of user to change. This argument may only be specified by team admins on paid teams.")] = None,
        value: Annotated[Optional[StrictStr], Field(description="Value to set a single key to. Usable only if `profile` is not passed.")] = None,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """users_profile_set

        Set the profile information for a user.

        :param token: Authentication token. Requires scope: `users.profile:write` (required)
        :type token: str
        :param name: Name of a single key to set. Usable only if `profile` is not passed.
        :type name: str
        :param profile: Collection of key:value pairs presented as a URL-encoded JSON hash. At most 50 fields may be set. Each field name is limited to 255 characters.
        :type profile: str
        :param user: ID of user to change. This argument may only be specified by team admins on paid teams.
        :type user: str
        :param value: Value to set a single key to. Usable only if `profile` is not passed.
        :type value: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._users_profile_set_serialize(
            token=token,
            name=name,
            profile=profile,
            user=user,
            value=value,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UsersProfileSetSchema",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _users_profile_set_serialize(
        self,
        token,
        name,
        profile,
        user,
        value,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if token is not None:
            _header_params['token'] = token
        # process the form parameters
        if name is not None:
            _form_params.append(('name', name))
        if profile is not None:
            _form_params.append(('profile', profile))
        if user is not None:
            _form_params.append(('user', user))
        if value is not None:
            _form_params.append(('value', value))
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded', 
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'slackAuth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/users.profile.set',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


