# coding: utf-8

"""
    Slack Web API

    One way to interact with the Slack platform is its HTTP RPC-based Web API, a collection of methods requiring OAuth 2.0-based user, bot, or workspace tokens blessed with related OAuth scopes.

    The version of the OpenAPI document: 1.7.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AdminUsersAssignRequest(BaseModel):
    """
    AdminUsersAssignRequest
    """ # noqa: E501
    team_id: StrictStr = Field(description="The ID (`T1234`) of the workspace.")
    user_id: StrictStr = Field(description="The ID of the user to add to the workspace.")
    is_restricted: Optional[StrictBool] = Field(default=None, description="True if user should be added to the workspace as a guest.")
    is_ultra_restricted: Optional[StrictBool] = Field(default=None, description="True if user should be added to the workspace as a single-channel guest.")
    channel_ids: Optional[StrictStr] = Field(default=None, description="Comma separated values of channel IDs to add user in the new workspace.")
    __properties: ClassVar[List[str]] = ["team_id", "user_id", "is_restricted", "is_ultra_restricted", "channel_ids"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AdminUsersAssignRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AdminUsersAssignRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "team_id": obj.get("team_id"),
            "user_id": obj.get("user_id"),
            "is_restricted": obj.get("is_restricted"),
            "is_ultra_restricted": obj.get("is_ultra_restricted"),
            "channel_ids": obj.get("channel_ids")
        })
        return _obj


